Print Friendly

# Class Ext.data.Tree

Package: | Ext.data
Class: | Tree
Extends: | Observable
Subclasses: | TreePanel
Defined In: | Tree.js

Represents a tree data structure and bubbles all the events for its nodes. The nodes in the tree have most standard DOM functionality.
Properties - Methods - Events

## Public Properties

Property | Defined By
--- | ---
| root : Node | Tree
The root node for this tree

## Public Methods

Method | Defined By
--- | ---
| Tree([`Node root`]) | Tree
| addEvents(`Object object`) : void | Observable
Copies any events from the passed object onto this object if they do not already exist. The passed object must also ...
| addListener(`String eventName`, `Function handler`, [`Object scope`], [`Object options`]) : void | Observable
Appends an event handler to this component
| fireEvent(`String eventName`, `Object... args`) : Boolean | Observable
Fires the specified event with the passed parameters (minus the event name).
| getNodeById(`String id`) : Node | Tree
Gets a node in this tree by its id
| getRootNode() : Node | Tree
Returns this root node for this tree
| hasListener(`String eventName`) : Boolean | Observable
Checks to see if this object is currently listening for a specified event
| on(`String eventName`, `Function handler`, [`Object options`]) : void | Observable
Appends an event handler to this element (shorthand for addListener)
| purgeListeners() : void | Observable
Removes all listeners for this object
| removeListener(`String eventName`, `Function handler`, [`Object scope`]) : void | Observable
Removes a listener
| setRootNode(`Node node`) : Node | Tree
Sets the root node for this tree
| un(`String eventName`, `Function handler`, [`Object scope`]) : void | Observable
Removes a listener (shorthand for removeListener)

## Public Events

Event | Defined By
--- | ---
| append : (`Tree tree`, `Node parent`, `Node node`, `Number index`) | Tree
Fires when a new child node is appended to a node in this tree.
| beforeappend : (`Tree tree`, `Node parent`, `Node node`) | Tree
Fires before a new child is appended to a node in this tree, return false to cancel the append.
| beforeinsert : (`Tree tree`, `Node parent`, `Node node`, `Node refNode`) | Tree
Fires before a new child is inserted in a node in this tree, return false to cancel the insert.
| beforemove : (`Tree tree`, `Node node`, `Node oldParent`, `Node newParent`, `Number index`) | Tree
Fires before a node is moved to a new location in the tree. Return false to cancel the move.
| beforeremove : (`Tree tree`, `Node parent`, `Node node`) | Tree
Fires before a child is removed from a node in this tree, return false to cancel the remove.
| insert : (`Tree tree`, `Node parent`, `Node node`, `Node refNode`) | Tree
Fires when a new child node is inserted in a node in this tree.
| move : (`Tree tree`, `Node node`, `Node oldParent`, `Node newParent`, `Number index`) | Tree
Fires when a node is moved to a new location in the tree
| remove : (`Tree tree`, `Node parent`, `Node node`) | Tree
Fires when a child node is removed from a node in this tree.

## Property Details

### root

`public Node root`
The root node for this tree
This property is defined by Tree.

## Constructor Details

### Tree

`public function Tree([`Node root`])`
Parameters:

- `root` : Node
  (optional) The root node

## Method Details

### addEvents

`public function addEvents(`Object object`)`
Copies any events from the passed object onto this object if they do not already exist. The passed object must also inherit from Observable for this method to have any effect.
Parameters:

- `object` : Object
  The object from which to copy events

Returns:

- `void`

This method is defined by Observable.

### addListener

`public function addListener(`String eventName`, `Function handler`, [`Object scope`], [`Object options`])`
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope {Object} The scope in which to execute the handler function. The handler function's "this" context.
  - delegate {String} A simple selector to filter the target or look for a descendant of the target
  - stopEvent {Boolean} True to stop the event. That is stop propagation, and prevent the default action.
  - preventDefault {Boolean} True to prevent the default action
  - stopPropagation {Boolean} True to prevent event propagation
  - normalized {Boolean} False to pass a browser event to the handler function instead of an Ext.EventObject
  - delay {Number} The number of milliseconds to delay the invocation of the handler after te event fires.
  - single {Boolean} True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

  Code:

      el.on('click', this.onClick, this, { single: true, delay: 100, stopEvent : true, forumId: 4 });

  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

  Attaching multiple handlers in 1 call
  Code:

      el.on({ 'click' : { fn: this.onClick scope: this, delay: 100 }, 'mouseover' : { fn: this.onMouseOver scope: this }, 'mouseout' : { fn: this.onMouseOut scope: this } });

  Or a shorthand syntax:
  Code:

      el.on({ 'click' : this.onClick, 'mouseover' : this.onMouseOver, 'mouseout' : this.onMouseOut scope: this });

Returns:

- `void`

This method is defined by Observable.

### fireEvent

`public function fireEvent(`String eventName`, `Object... args`)`
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

This method is defined by Observable.

### getNodeById

`public function getNodeById(`String id`)`
Gets a node in this tree by its id
Parameters:

- `id` : String

Returns:

- `Node`

This method is defined by Tree.

### getRootNode

`public function getRootNode()`
Returns this root node for this tree
Parameters:

- None.

Returns:

- `Node`

This method is defined by Tree.

### hasListener

`public function hasListener(`String eventName`)`
Checks to see if this object is currently listening for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

This method is defined by Observable.

### on

`public function on(`String eventName`, `Function handler`, [`Object options`])`
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `options` : Object
  (optional)

Returns:

- `void`

This method is defined by Observable.

### purgeListeners

`public function purgeListeners()`
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

This method is defined by Observable.

### removeListener

`public function removeListener(`String eventName`, `Function handler`, [`Object scope`])`
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

This method is defined by Observable.

### setRootNode

`public function setRootNode(`Node node`)`
Sets the root node for this tree
Parameters:

- `node` : Node

Returns:

- `Node`

This method is defined by Tree.

### un

`public function un(`String eventName`, `Function handler`, [`Object scope`])`
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

This method is defined by Observable.

## Event Details

### append

`public event append`
Fires when a new child node is appended to a node in this tree.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The newly appended node
- `index` : Number
  The index of the newly appended node

This event is defined by Tree.

### beforeappend

`public event beforeappend`
Fires before a new child is appended to a node in this tree, return false to cancel the append.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node to be appended

This event is defined by Tree.

### beforeinsert

`public event beforeinsert`
Fires before a new child is inserted in a node in this tree, return false to cancel the insert.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node to be inserted
- `refNode` : Node
  The child node the node is being inserted before

This event is defined by Tree.

### beforemove

`public event beforemove`
Fires before a node is moved to a new location in the tree. Return false to cancel the move.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `node` : Node
  The node being moved
- `oldParent` : Node
  The parent of the node
- `newParent` : Node
  The new parent the node is moving to
- `index` : Number
  The index it is being moved to

This event is defined by Tree.

### beforeremove

`public event beforeremove`
Fires before a child is removed from a node in this tree, return false to cancel the remove.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node to be removed

This event is defined by Tree.

### insert

`public event insert`
Fires when a new child node is inserted in a node in this tree.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node inserted
- `refNode` : Node
  The child node the node was inserted before

This event is defined by Tree.

### move

`public event move`
Fires when a node is moved to a new location in the tree
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `node` : Node
  The node moved
- `oldParent` : Node
  The old parent of this node
- `newParent` : Node
  The new parent of this node
- `index` : Number
  The index it was moved to

This event is defined by Tree.

### remove

`public event remove`
Fires when a child node is removed from a node in this tree.
Subscribers will be called with the following parameters:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node removed

This event is defined by Tree.

Ext - Copyright © 2006-2007 Ext JS, LLC
All rights reserved.